Option Strict Off
Option Explicit On 

Imports Microsoft.VisualBasic
Imports Syncfusion.Drawing
Imports Syncfusion.Windows.Forms
Imports Syncfusion.Windows.Forms.Grid
Imports System
Imports System.Collections
Imports System.Collections.Specialized
Imports System.ComponentModel
Imports System.Drawing
Imports System.IO
Imports System.Reflection
Imports System.Resources
Imports System.Windows.Forms

Namespace CellControlsGrid
    Public Class CellControlsForm
        Inherits Form
        Private WithEvents gridControl1 As GridControl
        Private buttonRow As Integer
        Private components As Container

        Public Sub New()
            MyBase.New()
            '
            ' Required for Windows Form Designer support
            '
            InitializeComponent()
            gridControl1.DefaultColWidth = 90
            gridControl1.DefaultRowHeight = 20
            gridControl1.CoveredRanges.Add(GridRangeInfo.Cells(1, 1, 2, 4))
            Dim standard As GridStyleInfo
            standard = gridControl1.BaseStylesMap("Standard").StyleInfo
            standard.Font.Bold = False
            standard.Font.Facename = "Verdana"
            standard.Font.Size = 9
            standard.TextColor = Color.FromArgb(240, 0, 21, 84)
            gridControl1.FloatCellsMode = GridFloatCellsMode.OnDemandCalculation
            gridControl1.BackColor = Color.FromArgb(240, 255, 255)
            ' grab some images...
            Dim imageList As imageList
            imageList = New imageList()
            imageList.Images.Add(SystemIcons.Warning.ToBitmap)
            imageList.Images.Add(SystemIcons.Application.ToBitmap)
            imageList.Images.Add(SystemIcons.Asterisk.ToBitmap)
            imageList.Images.Add(SystemIcons.Error.ToBitmap)
            imageList.Images.Add(SystemIcons.Exclamation.ToBitmap)
            imageList.Images.Add(SystemIcons.Hand.ToBitmap)
            imageList.Images.Add(SystemIcons.Information.ToBitmap)
            imageList.Images.Add(SystemIcons.Question.ToBitmap)
            standard.ImageList = imageList
            Dim USStates As ArrayList
            USStates = New ArrayList()
            USStates.Add(New USState("Alabama", "AL", 0))
            USStates.Add(New USState("Alaska", "AK", 1))
            USStates.Add(New USState("Arizona", "AZ", 2))
            USStates.Add(New USState("Arkansas", "AK", 4))
            USStates.Add(New USState("California", "CA", 4))
            USStates.Add(New USState("Colorado", "CO", 6))
            USStates.Add(New USState("Connecticut", "CT", 5))
            USStates.Add(New USState("Delaware", "DE", 0))
            USStates.Add(New USState("Florida", "FL", 2))
            USStates.Add(New USState("Georgia", "GA", 3))
            USStates.Add(New USState("Hawaii", "HI", 2))
            USStates.Add(New USState("Idaho", "ID", 1))
            USStates.Add(New USState("Illinois", "IL", 0))
            USStates.Add(New USState("Indiana", "IN", 5))
            USStates.Add(New USState("Iowa", "IA", 5))
            USStates.Add(New USState("Kansas", "KA", 6))
            USStates.Add(New USState("Kentucky", "KY", 6))
            USStates.Add(New USState("Louisiana", "LA", 1))
            standard.DataSource = USStates
            standard.DisplayMember = "LongName"
            '' changed - standard.ValueMember = "ShortName"
            'standard.MultiColumn = true;
            Dim icon As icon
            icon = New icon([GetType].Module.Assembly.GetManifestResourceStream("gridform.ico"))
            imageList.Images.Add(icon.ToBitmap)
            icon = New icon([GetType].Module.Assembly.GetManifestResourceStream("toolsform.ico"))
            imageList.Images.Add(icon.ToBitmap)
            standard.ImageList = imageList
            'for comboboxes
            Dim items As StringCollection
            items = New StringCollection()
            items.Add("One")
            items.Add("Two")
            items.Add("Three")
            items.Add("Four")
            items.Add("Five")
            items.Add("Six")
            items.Add("Seven")
            items.Add("Eight")
            items.Add("Nine")
            items.Add("Ten")
            gridControl1(1, 1).Text = "Cell Controls"
            gridControl1(1, 1).Font.Size = 14
            gridControl1(1, 1).Font.Bold = True
            gridControl1(1, 1).VerticalAlignment = GridVerticalAlignment.Middle
            gridControl1(1, 1).HorizontalAlignment = GridHorizontalAlignment.Center
            '255, 150, 77), 
            gridControl1(1, 1).Interior = New BrushInfo(GradientStyle.PathRectangle, Color.FromArgb(237, 240, 246), Color.FromArgb(42, 67, 126))
            gridControl1(1, 1).TextColor = Color.FromArgb(102, 110, 152)
            gridControl1(1, 1).CellType = "Static"
            Dim rowIndex As Integer
            rowIndex = 4
            Dim colIndex As Integer
            colIndex = 1
            gridControl1(rowIndex, colIndex).Text = "Static Cells - cannot be edited"
            gridControl1(rowIndex, colIndex).Font.Bold = True
            rowIndex = (rowIndex + 1)

            gridControl1(rowIndex, colIndex).Text = "Static"
            gridControl1(rowIndex, colIndex).CellType = "Static"
            gridControl1(rowIndex, (colIndex + 1)).Text = "Static2"
            gridControl1(rowIndex, (colIndex + 1)).CellType = "Static"
            gridControl1(rowIndex, (colIndex + 1)).ImageIndex = 8
            rowIndex = (rowIndex + 2)
            gridControl1(rowIndex, colIndex).Text = "Header Cells - used as row and column headers"
            gridControl1(rowIndex, colIndex).Font.Bold = True
            rowIndex = (rowIndex + 1)

            gridControl1(rowIndex, colIndex).Text = "HeaderText"
            gridControl1(rowIndex, colIndex).CellType = "Header"
            gridControl1(rowIndex, colIndex).BackColor = Color.FromArgb(208, 208, 208)
            gridControl1(rowIndex, (colIndex + 2)).Text = "HeaderText"
            gridControl1(rowIndex, (colIndex + 2)).CellType = "Header"
            gridControl1(rowIndex, (colIndex + 2)).BackColor = Color.FromArgb(208, 208, 208)
            rowIndex = (rowIndex + 2)
            gridControl1(rowIndex, colIndex).Text = "TextBox Cells - in place editing"
            gridControl1(rowIndex, colIndex).Font.Bold = True
            rowIndex = (rowIndex + 1)

            gridControl1(rowIndex, colIndex).Text = "TextBox"
            gridControl1(rowIndex, colIndex).CellType = "TextBox"
            gridControl1(rowIndex, (colIndex + 1)).Text = "TextBox/Image"
            gridControl1(rowIndex, colIndex).CellType = "TextBox"
            gridControl1(rowIndex, (colIndex + 1)).ImageIndex = 9
            rowIndex = (rowIndex + 2)
            gridControl1(rowIndex, colIndex).Text = "Checkbox Cells - supports triState/disabled states"
            gridControl1(rowIndex, colIndex).Font.Bold = True
            rowIndex = (rowIndex + 1)

            gridControl1.RowHeights(rowIndex) = 40
            gridControl1.TableStyle.CheckBoxOptions = New GridCheckBoxCellInfo("True", "False", "", False)
            gridControl1(rowIndex, colIndex).CellValue = False
            gridControl1(rowIndex, colIndex).Description = "Click Me"
            gridControl1(rowIndex, colIndex).CellType = "CheckBox"
            gridControl1(rowIndex, colIndex).TriState = False
            gridControl1(rowIndex, (colIndex + 1)).CellValue = True
            gridControl1(rowIndex, (colIndex + 1)).CellType = "CheckBox"
            gridControl1(rowIndex, (colIndex + 1)).TriState = True
            gridControl1(rowIndex, (colIndex + 1)).Description = "TriState"
            gridControl1(rowIndex, (colIndex + 1)).VerticalAlignment = GridVerticalAlignment.Middle
            gridControl1(rowIndex, (colIndex + 2)).Text = "True"
            gridControl1(rowIndex, (colIndex + 2)).CellType = "CheckBox"
            gridControl1(rowIndex, (colIndex + 2)).TriState = False
            gridControl1(rowIndex, (colIndex + 2)).Description = "Disabled"
            gridControl1(rowIndex, (colIndex + 2)).Enabled = False
            gridControl1(rowIndex, (colIndex + 2)).VerticalAlignment = GridVerticalAlignment.Bottom
            rowIndex = (rowIndex + 2)
            gridControl1(rowIndex, colIndex).Text = "PushButton Cells - flat, raised or sunken"
            gridControl1(rowIndex, colIndex).Font.Bold = True
            rowIndex = (rowIndex + 1)

            buttonRow = rowIndex
            gridControl1(rowIndex, colIndex).Description = "PushButton1"
            gridControl1(rowIndex, colIndex).CellType = "PushButton"
            gridControl1(rowIndex, colIndex).Font.Size = 8
            gridControl1(rowIndex, (colIndex + 2)).Description = "PushButton2"
            gridControl1(rowIndex, (colIndex + 2)).CellType = "PushButton"
            gridControl1(rowIndex, (colIndex + 2)).Font.Size = 8
            gridControl1(rowIndex, (colIndex + 2)).CellAppearance = GridCellAppearance.Raised
            gridControl1(rowIndex, (colIndex + 4)).Description = "PushButton3"
            gridControl1(rowIndex, (colIndex + 4)).CellType = "PushButton"
            gridControl1(rowIndex, (colIndex + 4)).Font.Size = 8
            gridControl1(rowIndex, (colIndex + 4)).CellAppearance = GridCellAppearance.Sunken
            rowIndex = (rowIndex + 2)
            gridControl1(rowIndex, colIndex).Text = "NumericUpDown Cells - with and without wrapping"
            gridControl1(rowIndex, colIndex).Font.Bold = True
            rowIndex = (rowIndex + 1)

            ' Wrapping, Range 0-20
            gridControl1(rowIndex, colIndex).CellType = "NumericUpDown"
            gridControl1(rowIndex, colIndex).Text = "5"
            gridControl1(rowIndex, colIndex).HorizontalAlignment = GridHorizontalAlignment.Right
            gridControl1(rowIndex, colIndex).NumericUpDown = New GridNumericUpDownCellInfo(0, 20, 5, 1, True)
            ' No wrapping, Range 1-20
            gridControl1(rowIndex, (colIndex + 2)).CellType = "NumericUpDown"
            gridControl1(rowIndex, (colIndex + 2)).HorizontalAlignment = GridHorizontalAlignment.Right
            gridControl1(rowIndex, (colIndex + 2)).Text = "1"
            gridControl1(rowIndex, (colIndex + 2)).NumericUpDown = New GridNumericUpDownCellInfo(1, 20, 1, 1, False)
            rowIndex = (rowIndex + 2)
            gridControl1(rowIndex, colIndex).Text = "ComboBox Cells - both editable (with autocomplete) and dropdown only"
            gridControl1(rowIndex, colIndex).Font.Bold = True
            rowIndex = (rowIndex + 1)

            gridControl1(rowIndex, colIndex).CellType = "ComboBox"
            gridControl1(rowIndex, colIndex).ChoiceList = items
            gridControl1(rowIndex, colIndex).Text = "Five"
            gridControl1(rowIndex, (colIndex + 2)).CellType = "ComboBox"
            gridControl1(rowIndex, (colIndex + 2)).ChoiceList = items
            gridControl1(rowIndex, (colIndex + 2)).Text = "Three"
            gridControl1(rowIndex, (colIndex + 2)).ExclusiveChoiceList = True
            rowIndex = (rowIndex + 2)
            gridControl1(rowIndex, colIndex).Text = "DropDown Color Edit Cells"
            gridControl1(rowIndex, colIndex).Font.Bold = True
            rowIndex = (rowIndex + 1)

            gridControl1(rowIndex, colIndex).CellType = "ColorEdit"
            gridControl1(rowIndex, colIndex).CellValue = Color.Aqua
            gridControl1(rowIndex, (colIndex + 2)).CellType = "ColorEdit"
            gridControl1(rowIndex, (colIndex + 2)).CellValue = Color.Plum
            rowIndex = (rowIndex + 2)
            gridControl1(rowIndex, colIndex).Text = "DropDown Calendar Cells"
            gridControl1(rowIndex, colIndex).Font.Bold = True
            rowIndex = (rowIndex + 1)

            gridControl1(rowIndex, colIndex).CellType = "MonthCalendar"
            gridControl1(rowIndex, colIndex).CellValue = DateTime.Now
            gridControl1(rowIndex, colIndex).Font.Size = 8
            gridControl1(rowIndex, (colIndex + 2)).CellType = "MonthCalendar"
            gridControl1(rowIndex, (colIndex + 2)).CellValue = DateTime.Now
            gridControl1(rowIndex, (colIndex + 2)).Font.Size = 8
            gridControl1.RowHeights(rowIndex) = (gridControl1.DefaultRowHeight - 2)
            rowIndex = (rowIndex + 2)
            gridControl1(rowIndex, colIndex).Text = "DropDown Grid Cells"
            gridControl1(rowIndex, colIndex).Font.Bold = True
            rowIndex = (rowIndex + 1)

            gridControl1(rowIndex, colIndex).CellType = "DropDownGrid"
            gridControl1(rowIndex, (colIndex + 2)).CellType = "DropDownGrid"
            rowIndex = (rowIndex + 2)
            gridControl1(rowIndex, colIndex).Text = "GridListControl Cells - both editable (with autocomplete) and dropdown only"
            gridControl1(rowIndex, colIndex).Font.Bold = True
            rowIndex = (rowIndex + 1)

            gridControl1.RowHeights(rowIndex) = (gridControl1.DefaultRowHeight - 2)
            gridControl1(rowIndex, colIndex).CellType = "GridListControl"

            '' added
            gridControl1(rowIndex, colIndex + 1).Text = "AL"
            gridControl1(rowIndex, colIndex).Text = "Alabama"
            '' change to above -  gridControl1(rowIndex, colIndex).Text = "AL" 'set to AL instead of Alabama as AL is ValueMember

            gridControl1(rowIndex, colIndex).Font.Size = 8
            gridControl1(rowIndex, (colIndex + 2)).CellType = "GridListControl"

            '' added 
            gridControl1(rowIndex, colIndex + 3).Text = "AL"
            gridControl1(rowIndex, colIndex + 2).Text = "Alabama"
            '' change to above - gridControl1(rowIndex, (colIndex + 2)).Text = "AL"

            gridControl1(rowIndex, (colIndex + 2)).ExclusiveChoiceList = True
            gridControl1(rowIndex, (colIndex + 2)).Font.Size = 8
            gridControl1.CurrentCell.MoveTo(2, 1)
            gridControl1.ActivateCurrentCellBehavior = GridCellActivateAction.DblClickOnCell

            Dim cr As GridDropDownGridListControlCellRenderer = gridControl1.CellRenderers("GridListControl")
            cr.ListControlPart.ShowColumnHeader = False

        End Sub
        Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)

            If disposing Then
                If (Not (components) Is Nothing) Then
                    components.Dispose()
                End If
            End If
            MyBase.Dispose(disposing)

        End Sub
        Private Sub InitializeComponent()

            Dim resources As System.Resources.ResourceManager
            resources = New System.Resources.ResourceManager(GetType(CellControlsForm))
            Me.gridControl1 = New GridControl()
            CType(Me.gridControl1, System.ComponentModel.ISupportInitialize).BeginInit()
            Me.SuspendLayout()
            ' 
            ' gridControl1
            ' 
            Me.gridControl1.ColCount = 13
            Me.gridControl1.DefaultColWidth = 65
            Me.gridControl1.DefaultGridBorderStyle = Syncfusion.Windows.Forms.Grid.GridBorderStyle.Dotted
            Me.gridControl1.DefaultRowHeight = 17
            Me.gridControl1.Dock = System.Windows.Forms.DockStyle.Fill
            Me.gridControl1.FillSplitterPane = False
            Me.gridControl1.Name = "gridControl1"
            Me.gridControl1.RowCount = 40
            Me.gridControl1.Size = New System.Drawing.Size(560, 374)
            Me.gridControl1.TabIndex = 0
            Me.gridControl1.Text = "gridControl1"
            Me.gridControl1.ThemesEnabled = True
            Me.gridControl1.VerticalThumbTrack = True
            Me.gridControl1.HorizontalThumbTrack = True
            AddHandler Me.gridControl1.CellButtonClicked, New Syncfusion.Windows.Forms.Grid.GridCellButtonClickedEventHandler(AddressOf gridControl1_CellButtonClicked)
            ' 
            ' CellControlsForm
            ' 
            Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
            Me.ClientSize = New System.Drawing.Size(560, 374)
            Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.gridControl1})
            Me.Name = "CellControlsForm"
            Me.Text = "Cell Controls"
            CType(Me.gridControl1, System.ComponentModel.ISupportInitialize).EndInit()
            Me.ResumeLayout(False)

        End Sub
        <STAThread()> _
        Public Shared Sub Main()

            Application.Run(New CellControlsForm())

        End Sub
        Private Sub gridControl1_CellButtonClicked(ByVal sender As Object, ByVal e As GridCellButtonClickedEventArgs)

            If (e.RowIndex = buttonRow) Then
                Select Case e.ColIndex
                    Case 1
                        MessageBox.Show("You clicked button 1.")
                        'End Section
                    Case 3
                        MessageBox.Show("You clicked button 2.")
                        'End Section
                    Case 5
                        MessageBox.Show("You clicked button 3.")
                        'End Section
                    Case Else
                        'End Section
                End Select
            End If

        End Sub

        '' added 
        Private Sub gridControl1_CurrentCellCloseDropDown(ByVal sender As Object, ByVal e As Syncfusion.Windows.Forms.PopupClosedEventArgs) Handles gridControl1.CurrentCellCloseDropDown
            'Dim cc As GridCurrentCell = Me.gridControl1.CurrentCell
            'If Me.gridControl1(cc.RowIndex, cc.ColIndex).CellType = "GridListControl" Then
            '    cc.ConfirmChanges(False)
            '    'uses the value member in the next cell
            '    Dim state As USState = Me.gridControl1(cc.RowIndex, cc.ColIndex).CellValue
            '    Me.gridControl1(cc.RowIndex, cc.ColIndex + 1).CellValue = state.ShortName
            '    '

            'End If

        End Sub

        Private Sub gridControl1_CurrentCellShowingDropDown(ByVal sender As Object, ByVal e As Syncfusion.Windows.Forms.Grid.GridCurrentCellShowingDropDownEventArgs) Handles gridControl1.CurrentCellShowingDropDown
            Dim cc As GridCurrentCell = Me.gridControl1.CurrentCell
            If Me.gridControl1(cc.RowIndex, cc.ColIndex).CellType = "GridListControl" Then
                Dim cr As GridDropDownGridListControlCellRenderer = cc.Renderer
                cr.ListControlPart.BackColor = Color.Red
                'cr.ListControlPart.AutoSizeColumns = False
                ''''cr.ListControlPart.Grid.ColWidths(1) = Me.gridControl1.ColWidths(1) - 1
                ''''cr.ListControlPart.Grid.ColWidths(2) = Me.gridControl1.ColWidths(2) - 1
                ''''e.Size = New Size(Me.gridControl1.ColWidths(1) + Me.gridControl1.ColWidths(1), e.Size.Height)
                ''''cr.ListControlPart.Grid.HScrollBehavior = GridScrollbarMode.Disabled
            End If
        End Sub

        Private Sub gridControl1_CurrentCellKeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles gridControl1.CurrentCellKeyDown
            'If e.KeyCode = Keys.Up Or e.KeyCode = Keys.Down Or e.KeyCode = Keys.Left Or e.KeyCode = Keys.Right Then
            '    e.Handled = True 'don't
            'End If
        End Sub
    End Class
End Namespace
